---
id: sprint3
title: "Sprint 3: Starting to develop the automation systems"
sidebar_label: Sprint 3
slug: /sprint3
---


### What are the parallels between the services run in AWS and the services run in Azure?
-------------------------------

Based on the research conducted in the second sprint a basic understanding of the system was achieved, but most of that information is **theoretical**
and to truly understand the **limitations and challenges** of running Raven on an Azure infrastructure through Terraform, it had to be **practically implemented**.


![img](../../static/img/PackerProvisioing.png)
Figure 1 - Packer provisioning logs

The first challenge that came forward was creating a machine image for the Raven product. Based on the already exiting images used for

[AWS](../../portofolio/glossary#aws-amazon-web-services) it was discovered that the best OS to use would be a Debian. Afterward, it was necessary to make sure that the
process of creating and updating the image is secure as well.

The secure image was compiled by automating the process of creating  through **Packer** as it was discovered in the second sprint, and
then **secured** through the **GitLab pipeline** by hiding the variables needed for deployment such as the **service principal credentials** which were created manually.

![img](../../static/img/SourceSetupFunc.png)
Figure 2 - Running  Packer Virtual Machine

Initially, the image was created **locally** using Packer, and there were many challenges that needed to be overcome, such as **accessing the machine**
through SSH and making available the **necessary ports** through **port forwarding** the VirtualBox with an SSH tunnel, **creating a correct preseed** (Debian configuration file)
needed for Debian machine, **learning how to use Packer**.

Throughout this process, there were multiple challenges. The first one was using the **free account for Azure**. 
While giving the user a certain number of free credits it did not give the **necessary number of Virtual CPUs** needed to run the Raven platform. 

On top of that, **Packer and Terraform** are **not fully developed tools**, while **they advertise** that they can directly create and destroy the resources that are being provisioned some of the resources
are **state locked** if they are **deleted manually**. Therefore, a workaround was to delete all created resources by hand to make sure
that nothing remained over for the next try. And each failed pipeline leaves a prePackering (a machine that is spun up to create the image) machine running and keeps the SSH connections alive if
the keys are available.

Secondly, **an attempt** was made into creating an image that had all provisioned functions for running Raven preset with the values
needed to create the machine. This proved to come with its own set of **problems**. To do this, a Virtual machine based on 
the packaged image was set up and then the setup functions were run. But getting the **correct credentials** and determining the **right values**
was easier said than done. Based on discussions with the DTACT developers the best way to deploy Raven was determined.


![img](../../static/img/machineInAzureBasedOnProvisionedImage.png)
Figure 3 - Terraformed Virtual Machine with the Packered image


Services had to be run in a **certain order**, so they may be used by other services. First, the **Docker image** had to be created, and then run locally, afterward, 
**Elasticsearch**, **Vault**, and **Consul services** had to be run, **Vault needed Consul** for its storage system, and
both the address for Docker host, Vault host and Consul host was needed for **raven-formation** service. On top of that, the IP of the
machine had to be used for setting up **raven-formation**.

All in all, it proved that starting all services on the same machine is not possible because of the actual platform design.
While it is outside the scope of the project it is believed that with more time and development,
running all services from one machine **could be achieved** in a Packered machine.

### What are the requirements for fully running Raven products and what are the security limitations of this product?


![img](../../static/img/RavenDeploymentDependency.png)
Figure 4 - Service dependencies


Creating an image that has all the Raven services installed but not activated, produce a better understanding of the dependencies
that take place inside Raven, and reveal some of the **possible security issues** that must be taken into consideration.

During this research project, adding all services on the same machine, the **first impression** was that the platform could run in one powerful machine. But 
in a real environment, **scalability** needs to be taken into consideration, therefore each Raven service would require its own dedicated
machine.

Based on the interviews and the weekly meetings that were made with the company mentor a **better understanding** of how each
component is **dependent on each other** during the deployment of Raven. Therefore, a new deployment plan was made.

As it can be seen in Figure 7, some services are dependent on other services to run, so the first ones that can be deployed are
**Docker**, **Consul**, and **MariaDB**. Furthermore, because the services are supposed to be run inside virtual machines, inside a private
network, not all machines need to be accessible from the outside. Such as the **Docker machine**, the **raven-workflow machine**, and
possibly the **MariaDB machine**. These can just have a **private IP** and should be made available from machines within the same network.

The ideal order of deployment based on the dependency model is:
1.	Docker
2.	Consul
3.	Vault
4.	Raven-Workflow
5.	Raven-Formation
6.	MariaDB
7.	Portal-API


Out of all the services, the hardest to configure are [Consul](https://www.consul.io/docs/intro) and [Vault](https://www.vaultproject.io/docs/what-is-vault),
as they are the main **credential and services management system** for Raven. When deploying them different steps must be taken into
consideration. Firstly, **Consul needs to be created and unsealed just like Vault**.
Furthermore, Consul works in **a service mesh**, meaning that it has multiple nodes that run and keep track of all the services
at the same time, meaning that if **one node goes down** other nodes can still **retain the data** of the services.

On top of that for **better monitoring**, Consul can be run in multiple cloud platforms. This was attempted between AWS and Azure;
the **problem** was that a specific kind of configuration for multi-cloud service mesh needed to be **developed**.
It was the end achieved by **different means**. By **opening the security group** between AWS and Azure and giving static IPs to
the Consul nodes in Azure and **freeing up one of the Elastic IPs** in AWS for the Consul machines. This is **not the intended** way of communicating between Consul 
machines and it posed a security threat. The **intended way** was creating an
**inter-cloud service mesh** with a specific configuration for accessing each one. This would have meant redeploying the Consul nodes
in the AWS environment as well leading to be kept as an advice rather than a full implementation.

Afterward, the next challenge is **setting up** Vault. This service is initially easy to start, but the challenge comes with saving the
**unsealing key** and **root token** in a safe manner. This is done together with the **Azure Key Vault** system for this project but custom scripts
have to be created for this use case. This has been done in the duration of [Sprint 4](./sprint4) and can be further investigated there.

At the end of the 3rd sprint, these are all the services that I was able to configure due to the limitations of the demo account.
But the rest of the services were implemented in the [4th sprint](./sprint4).

### Conclusion
--------------------------

**How is a secure image created for the project and how is it deployed to the cloud?**

In order to have a secure image, you have to create your own. This means not using the premade Azure images. This ensures compatibility
with the applications and gives control of what is installed on the machine before it is created. In this case, all the setup scripts and services
were preloaded, and then research was conducted into how configuration must be achieved.
In order for a machine to be created in the Azure environment, it needs the right service principal credentials which are application-only
access credentials, and must be securely stored.

**What are the obstacles that need to be overcome?**

The process of configuring a secure image takes a lot of repetition, trial, and error. While the model of the machine is easy to construct 
the implementation must be properly tested and checked to ensure that it works as intended and that it can be run in the intended environment.



